<?php
/**************************************************************
Google site map for vBulletin
(c) by T2DMan - Michael Brandon 
    michael@time2dine.co.nz

Get updates from http://forum.time2dine.co.nz/showthread.php?t=3976

version 1.2 1 July 2005

-access to this file is password protected 
 the same password as the database via the vb includes/config.php file

-creates an index file and multiple site maps to less than the max 
 permitted by Google

-the site map files are created in the root directory
-for the program to create the files, the root directory must be minimum chmod 750
-or note the names of the files and precreate them yourself
-the program will create the $file if it does not already exist

adds 
-forums - with paginations of forums (excluding redirects and password protected)
-threads - with pagination of threads (excluding invisible threads=soft deleted, and threads inside password protected forums)
-archive forum pages with paginations
-archive versions of threads with paginations 
-members

restrictions
-not programmed regarding forum permissions - but although Google may try to get the pages, it will get a permission denied message, so we can live with that.

extra
-extra urls from other program types
-configure vbsitemap-xtrafile.php (add in name of following file - file.txt)
-add a new url per line onto file.txt, and a gzipped file will be created for it, and added to the site index file.


**************************************************************
inspired by
http://forums.digitalpoint.com/showthread.php?t=17798

http://code.google.com/sm_thirdparty.html
*/

//directory that the vBulletin forum is in. 
//comment out the one not applicable to your forum

$v=0;//3.5;//vBulletin version 3.5 (or leave as zero for v3.3-3.7)
$base=""; //if in root
//$base="forum/"; //if in the subdirectory forum


require $base.'includes/config.php';
if ($v==3.5){
$dbusername=$config['MasterServer']['username'];
$dbpassword=$config['MasterServer']['password'];
$servername=$config['MasterServer']['servername'];
$dbname=$config['Database']['dbname'];
$tableprefix=$config['Database']['tableprefix'];
}

//**************************************************************
head();


if($dbusername<>$username AND $dbpassword<>$password) {
entry();
}
($ping=="on")?$ping=true:$ping=false;
//**************************************************************


//add members userid pages to the sitemap
$adduserid=true;

// root - home page
$http="http://";

//add lastmod flag for threads & forums-based on the date/time of lastpost
$lastmod=true;//false; 

// add thread archive urls to site map
// will add them if firstly the archives are enabled,
// and then checks that you want to add them
$addarchive=true;
$addthreadarchive=false;//false; #- personally I go straight to the actual threads

$archiveurl="archive/index.php/";

//add pagination of forums and threads
$addforumpagination=true;
$addthreadpagination=true;

// the var string for forum display
// if your url is forumdisplay.php?f=73  then this would be f=
$forumq = '?f=';
$pageq = '&amp;page='; #pagination of forum & thread pages

// the var string for your thread display
// if your url is  showthread.php?t=872 then is t=
$threadq = '?t=';

// the var string for your member display
// if your url is  member.php?u=872 then is t=
$memberq = '?u=';


// url text file names - make them writable - or make your root directory chmod 777 and it will create itself.!!!
//starts from scratch - add the resulting file to your own master site map index
$sitemapindex="sitemap_vb_index.xml";

$numoffiles=1; //running total of the number of file we are up to

$file1 = 'sitemap'; //additional files are created with sitemap2.xml.gz etc
$file2 = '.xml.gz';

$file = $file1.$numoffiles.$file2;

// forum priority , thread priority, member priority, change frequency thread and forum see the sitemaps documentation
$fpriority = "0.8";
$tpriority = '1.0';    
$mpriority = '0.1';    


$fchange ='daily' ;
$tchange ='weekly';    
$mchange ='monthly';    

// base and forum base change and priority
$bchange ='hourly';
$bpriority = '1.0';


//counting number of url's processed
//rounded down from max 50k url's allowed-kept to 20k so the file is not too large to check manually - the program goes several over the number specified
$max=20000;//49500;
$maxsize=10000000; //10meg - rounded down 

//end of configuration
//**************************************************************

$txt=""; //contains the xml string that gets written to $file
$size=0; //counts the characters in the file up to max size then new file
$countertotal=0;//total url's in all the files
$counter=0; //running total of number of url's in a file


include('vbsitemap-xtrafile.php');

// base url of the forum with trailing slash
$home=$http.$_SERVER['SERVER_NAME']."/";
$base = $home.$base;

//**************************************************************
//open multi page file
$multifile=$sitemapindex;

if(!file_exists($home.$multifile)) $notopen=1;

$multihandle = fopen($multifile, "w");
if($notopen) chmod($multifile, 0777);

//control file	
fwrite( $multihandle, '<?xml version="1.0" encoding="UTF-8"?>
<sitemapindex xmlns="http://www.google.com/schemas/sitemap/0.84"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84
http://www.google.com/schemas/sitemap/0.84/siteindex.xsd">
');



//**************************************************************
//write new file to sitemap index
$a = date('Y-m-d\TH:i:s\Z');

//xtrafile - configure vbsitemap-xtrafile.php to include a list of url's
//the url's will be added to their own file and added to the sitemap index
if($xtrafile){

xtra();

fwrite( $multihandle, "<sitemap>
   <loc>{$home}{$xtrafilegz}</loc>
   <lastmod>{$a}</lastmod>
</sitemap>
");

}
//end xtra file

fwrite( $multihandle, "<sitemap>
   <loc>{$home}{$file}</loc>
   <lastmod>{$a}</lastmod>
</sitemap>
");

//**************************************************************
//open first site map file

if(!file_exists($home.$file)){
	$notopen=1;
} 
$handle = gzopen($file, 'w9');

if($notopen==1){
	chmod($file, 0777);
}

$txt='<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.google.com/schemas/sitemap/0.84"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84
http://www.google.com/schemas/sitemap/0.84/sitemap.xsd">

';

gzwrite($handle, $txt);
$size+=strlen($txt);


//**************************************************************
//report on files written

echo "<font color=red>";
if($ping){
echo"Google has been pinged with the index file location. You will receive an email if the ping is unsuccessful.<br /><br />You do not need to have the site index file listed on your account, but if you do, you are able to see the last time that Google uploaded the file via the Google account.<br /><br />This ping acts as an automated resubmit.";
} else{
echo "Please manually add the site map index file to your Google account.<br /><br />It the file has been changed since last time, Google will revisit the files, but better to manually click on the Google account resubmit link";
}

echo "</font><br /><br />";

?>
<hr /><br />
<a target="_blank" href="<?=$home.$sitemapindex?>">Google site map index file</a> <font color=red><?=$home.$sitemapindex?></font><br /><br /> 
<?=$xtrafilemessage?>
<a target="_blank" href="<?=$home.$file?>">Site map file <?=$numoffiles?></a> <font color=red><?=$home.$file?></font> <br />

<?

$basestr = " $bchange $bpriority";
$fstr = " $fchange $fpriority";
$tstr = " $tchange $tpriority";

    $connection = mysql_connect($servername, $dbusername, $dbpassword ) or die("Database is down please try again");
    $db = mysql_select_db($dbname, $connection) or die ("NO DATABASE" );

//**************************************************************
//archive entry - first check if archive enabled and get pagination 
//and other information
$fquery="SELECT varname,value from setting where varname = 'archiveenabled' or varname='archive_threadsperpage' or varname = 'archive_postsperpage' or varname = 'maxthreads' or varname = 'maxposts'";
$results = mysql_query($fquery) or DIE("$fquery" );

while ($result=mysql_fetch_array($results)){
	$$result['varname']=$result['value'];
}
//stop div by zero errors
if($archive_threadsperpage==0) $archive_threadsperpage=1;
if($archive_postsperpage==0) $archive_postsperpage=1;
	
//**************************************************************
//home pages - including archive home page

$txt="<url>
<loc>{$home}</loc>
<lastmod>{$a}</lastmod>
<changefreq>{$bchange}</changefreq>
<priority>{$bpriority}</priority>
</url>

";
$counter++;


if($base<>$home){
$txt.="<url><loc>{$base}</loc>
<lastmod>{$a}</lastmod>
<changefreq>{$bchange}</changefreq>
<priority>{$bpriority}</priority>
</url>

";
$counter++;
}


if($archiveenabled and $addarchive){
$txt.="
<url><loc>{$base}{$archiveurl}</loc>
<lastmod>{$a}</lastmod>
<changefreq>{$bchange}</changefreq>
<priority>{$bpriority}</priority>
</url>

";
$counter++;
}

$forums = $tableprefix."forum";
$threads = $tableprefix."thread";
$members = $tableprefix."user";                            



//**************************************************************
//add forums - both actual (and pagination) and archive (and pagination)

$fquery = "SELECT forumid, lastpost, threadcount FROM $forums where link='' and  password='' order by forumid";
$results = mysql_query($fquery) or DIE("$fquery" );
$num_rows = mysql_num_rows($results);

while ($row=mysql_fetch_array($results))
{


   $url = $base."forumdisplay.php".$forumq.$row['forumid'];    
   $url2 = $base."archive/index.php/f-".$row['forumid'].".html";
    $txt.= "<url>
<loc>{$url}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>

";
$counter++;
counter();

//add pagination of forum
if($addforumpagination and ceil($row['threadcount']/$maxthreads)>1){
for ($ai = 2; $ai <= ceil($row['threadcount']/$maxthreads); $ai++){
$url4 = $base."forumdisplay.php{$forumq}{$row['forumid']}$pageq{$ai}";
	$txt.="<url>
<loc>{$url4}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="
<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>

";
$counter++;
counter();

	}
} //end when only one page for forum 


//archive
if($archiveenabled and $addarchive){
$txt.="<url>
<loc>{$url2}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>

";
$counter++;
counter();

//add pagination for archive - based on threads per forum
if(ceil($row['threadcount']/$archive_threadsperpage)>1){

for ($ai = 2; $ai <= ceil($row['threadcount']/$archive_threadsperpage); $ai++){
	$url3 = $base."archive/index.php/f-{$row['forumid']}-p-{$ai}.html";
	$txt.="<url>
<loc>{$url3}</loc>
<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>

";
$counter++;
counter();
	}
} //end when only one page for forum archive
}//end of archive

}//end of forum loop

gzwrite($handle, $txt);
$size+=strlen($txt);
$txt='';

//**************************************************************
//add threads - both actual and archive versions

$tquery = "SELECT threadid, $threads.lastpost,$threads.replycount FROM $threads,$forums where visible=1 and $threads.forumid=$forums.forumid and password='' order by threadid desc";

$results = mysql_query($tquery) or DIE("$tquery" );
$num_rows = mysql_num_rows($results);

while ($row=mysql_fetch_array($results)){
   $url = $base."showthread.php".$threadq.$row['threadid'];    
   $txt .= "<url>
<loc>{$url}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="<changefreq>{$tchange}</changefreq>
<priority>{$tpriority}</priority>
</url>

";
$counter++;

//add pagination for threads - based on posts per threads
if(ceil($row['replycount']/$maxposts)>1){

for ($ai = 2; $ai <= ceil($row['replycount']/$maxposts); $ai++){
   $url5 = "{$base}showthread.php{$threadq}{$row['threadid']}{$pageq}{$ai}";    
	$txt.="<url>
<loc>{$url5}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>

";
$counter++;
	}
} //end when only one page for threads

//achive site map
$url2 = $base."archive/index.php/t-".$row['threadid'].".html";
if($archiveenabled and $addthreadarchive){
$txt.="<url>
<loc>{$url2}</loc>
";
if($lastmod) $txt.="<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>
";
$txt.="<changefreq>{$tchange}</changefreq>
<priority>{$tpriority}</priority>
</url>

";
$counter++;

//add pagination for archive - based on threads per forum
if(ceil($row['replycount']/$archive_postsperpage)>1){

for ($ai = 2; $ai <= ceil($row['replycount']/$archive_postsperpage); $ai++){
	$url3 = $base."archive/index.php/t-{$row['threadid']}-p-{$ai}.html";
	$txt.="<url>
<loc>{$url3}</loc>";
if($lastmod) $txt.="
<lastmod>".date('Y-m-d\TH:i:s\Z',$row['lastpost'])."</lastmod>";
$txt.="<changefreq>{$fchange}</changefreq>
<priority>{$fpriority}</priority>
</url>
";
$counter++;
	}
} //end when only one page for forum archive

}//end of archive
$counter++;
counter();
gzwrite($handle, $txt);
$size+=strlen($txt);
$txt='';

}//end of look for threads


//**************************************************************
//add members profile pages

if($adduserid) {
$tquery = "SELECT userid FROM $members";

$results = mysql_query($tquery) or DIE("$tquery" );
$num_rows = mysql_num_rows($results);

for ( $i = 0; $i < $num_rows; $i++)
{
   $row = mysql_fetch_row($results);
   // print_r($row);
   $url = $base."member.php".$memberq.$row[0];    
   $txt .= "<url>
<loc>{$url}</loc>
<changefreq>{$mchange}</changefreq>
<priority>{$mpriority}</priority>
</url>

";

$counter++;
counter();
gzwrite($handle, $txt);
$size+=strlen($txt);
$txt='';

}
}//end of member loop



//close site map file
gzwrite($handle, "</urlset>");
gzclose($handle);

//close index file
fwrite( $multihandle, "</sitemapindex>");
fclose($multihandle);


//****************************************************
//ping Google
if($ping){
$google_url = 'http://www.google.com/webmasters/sitemaps/ping?sitemap=';
$ping_url = rawurlencode( $home . $multifile);

$churl = @fopen($google_url.$ping_url,'r');

if (!$churl) mail($config['Database']['technicalemail'], 'Google ping failed', date('Y-m-d H:i'));



}
//****************************************************
//finish
$countertotal+=$counter;
?>
size <?=$size?>, 
number of url's <?=$counter?><br /><br />
finished - <?=$countertotal?> url's<br /><br />
<a href="<?=$_SERVER['PHP_SELF']?>">Recreate files</a>
<?
$counter=0;
footer();
exit;

//****************************************************
function counter(){
global $countertotal,$counter,$size,$handle,$max,$maxsize,$txt,$file1,$file2,$numoffiles,$home,$multihandle,$base;

if($size>=$maxsize or $counter>=$max){

	$a = date('Y-m-d\TH:i:s\Z');

	gzwrite($handle, $txt);
	$size+=strlen($txt);

	echo "size $size, ";
	echo "number of url's $counter<br />";

	$size=0;//cumulative text length of file
	$txt="";

	gzwrite($handle, '</urlset>');
	gzclose($handle);

	$numoffiles++;
	$countertotal+=$counter;
	$counter=0;//number of url's
	
	//new data file
	$file=$file1.$numoffiles.$file2;
	
	if(!file_exists($home.$file)){
		$notopen=1;
	} 
	$handle = gzopen($file, 'w9');
	
	if($notopen==1){
		chmod($file, 0750);
	}
	
?>
<br /><a target="_blank" href="<?=$home.$file?>">Site map file <?=$numoffiles?></a>  <font color=red><?=$home.$file?></font> <br />
<?

	//write file header to new file
	$txt='<?xml version="1.0" encoding="UTF-8"?>';
	$txt.='
<urlset xmlns="http://www.google.com/schemas/sitemap/0.84"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84
http://www.google.com/schemas/sitemap/0.84/sitemap.xsd">';

	gzwrite($handle, $txt);
	$size+=strlen($txt);
	$txt='';

	//write new file to sitemap index
	fwrite( $multihandle, "<sitemap>
   <loc>{$home}{$file}</loc>
   <lastmod>$a</lastmod>
</sitemap>
");
	


}
}

//**************************************************************
function head(){

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<style TYPE="text/css">
h1,tr,td,ul,li,input{
	font-family:Arial, Helvetica, sans-serif,Tahoma,Geneva;
	font-size:12px;
}

h1{
	margin-bottom:0;
	font-weight:bold;
	color:#993366;
	font-size:16px;
}
</style>

<title>vBulletin Google Sitemap Creator-Time2Dine MarketItOnline</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<body>
<table>
<tr><td>
<form ACTION="<?=$_SERVER['PHP_SELF']?>" METHOD="post">
<h1>vBulletin Google Site Map Creator v1.2 1 July 2005</h1>
by T2DMan - Michael Brandon,<br /><br />
<b>A Google site map is one step:</b>
<ul style="margin:0;">
<li>Make sure you also have your onpage optimization correct, 
<li>and plenty of links
<li>see the experts at <a href="http://www.marketitonline.co.nz">MarketItOnline</a>
<li>see <a href="http://forum.time2dine.co.nz/showthread.php?t=3976">vBulletin Google Site Map</a> for script updates</li>
</ul>
<br />
<b>Google Site Maps</b><br />
<a target="_blank" href="https://www.google.com/webmasters/sitemaps/login">Login</a><br />
<a target="_blank" href="https://www.google.com/webmasters/sitemaps/docs/en/about.html">What is Google Site Maps</a><br />
<a target="_blank" href="https://www.google.com/webmasters/sitemaps/docs/en/protocol.html">Google Site Maps Protocol</a><br />
<a target="_blank" href="https://www.google.com/webmasters/sitemaps/stats">Google Site Map Stats</a><br /><br />

<?
}

//**************************************************************
function entry(){

?>
<b>Instructions</b><br/>
Please make sure that you have personalized the configuration of this file (directly on the file)<br />
- You can either ping the Google servers with the option below, or manually submit the one site index file after logging in to Google
<br /><br />

Username <input name=username><br /><br />
Password <input name=password type=password><br /><br />
(same as database details)<br /><br />
Ping <input name=ping type=checkbox><br /><br />
<input type=submit value="Create vBulletin Google Site Map">
</form>
<?
footer();
exit;
}

//**************************************************************
function footer(){

?>
</body>
</html>
<?
}
?>